/*
 *  netcom.h
 *  TULIP
 *
 *  Created by Jim on Sat Oct 12 2002.
 *  Copyright (c) 2002 Pandora Products. All rights reserved.
 *
 */
 
 #ifndef NETCOM_H
 #define NETCOM_H	1

#include "tgtypes.h"
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <net/route.h>
#include <net/if.h>
#include <sys/queue.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>

typedef enum {
				NETCOM_SER,
				NETCOM_TCP
			} NETCOM_TYPE;
			
typedef enum {
				NETCOM_OPEN,
				NETCOM_READY
			} NETCOM_STATE;

#define NETCOM_VALID	'NETC'

typedef struct comlist_struct {
			TG_UINT32 valid;
			int duplicate;			// TRUE if duplicate socket
			struct comlist_struct *next;
			int socket;             // Socket handle
			int to_socket;			// Other end
			struct sockaddr_in addr;// IP address data
			NETCOM_TYPE type;
			NETCOM_STATE state;
			struct comlist_struct *buddy;	// Put dup handle here
		} NETCOM_CHANNEL;
		
		
NETCOM_CHANNEL *netcom_netcreate( int port );
NETCOM_CHANNEL *netcom_netduplicate( NETCOM_CHANNEL *net );

void netcom_netdestroy( NETCOM_CHANNEL *net );
TG_BOOL netcom_select(int msec,NETCOM_CHANNEL *net);
int netcom_read( NETCOM_CHANNEL *net,char *buf,int len );
int netcom_gets( TG_BOOL echo,NETCOM_CHANNEL *net,char *buf,int len );
int netcom_write( NETCOM_CHANNEL *net,char *buf,int len);

#endif


