/***************************************************************************
*  Copyright (C) 1997,  Tollgrade Communications, Inc.  All Rights Reserved.
****************************************************************************
*
*  Module Name: TGTIMER.H
*
*  Description: Asynchronous timer functions
*
*  Notes: 
*
***************************************************************************/

#ifndef __TGTIMER_H_INCLUDED
#define __TGTIMER_H_INCLUDED


/*************************************
*  C O M P I L E R    O P T I O N S
*************************************/


/********************************
*  I N C L U D E    F I L E S
********************************/

#include <sys/time.h>
#include "tgtypes.h"

/***********************************************************
*  G L O B A L    C O N S T A N T    D E F I N I T I O N S
***********************************************************/


/**********************************************************
*  G L O B A L    I N -  L I N E    M A C R O S
**********************************************************/


/****************************************************
*  G L O B A L    T Y P E D E F S
****************************************************/

typedef struct timeval  TG_TIMER_STRUCT;    // Use POSIX struct
#define TG_TIME_STRUCT	TG_TIMER_STRUCT		// Equate the two

/***********************************************************
*  G L O B A L    F U N C T I O N    P R O T O T Y P E S
***********************************************************/


void iTIMER_Start (TG_TIMER_STRUCT *pTimerInfo);
TG_BOOL iTIMER_Finished (TG_TIMER_STRUCT *pTimerInfo, TG_UINT32 ui32TargetMilliSecs);
void  TG_Copy_time( TG_TIMER_STRUCT *from,TG_TIMER_STRUCT *to );

TG_UINT32 iTIMER_GetElapsedMillisecs (
                TG_TIMER_STRUCT *   pTimerInfo1,    // start time
                TG_TIMER_STRUCT *   pTimerInfo2);   // current or finished time

#define TIMER_Start		iTIMER_Start
#define TIMER_Finished  iTIMER_Finished

#endif  // __TIMER_H_INCLUDED

