//*****************************************************************************
/*

    Header Name: TGTYPES.H


    Description: Tollgrade Data Types for DMU/TEM

	Convert to MAC version 9 September 2000


    Notes: This contains the data types used throughout the DMU/TEM
    products.  These types our own definitions of simple data types
    as well as system-wide structure definitions, unions, etc.

*/
//*****************************************************************************
#ifndef __TGT_H_INCLUDED
#define __TGT_H_INCLUDED

#define _MT

//***
// SIMPLE TYPE DEFINITIONS
//***
typedef unsigned char           TG_BYTE;
typedef unsigned char           TG_UINT8;
typedef char                    TG_CHAR;
typedef unsigned short          TG_WORD;
typedef TG_WORD                 TG_UINT16;
typedef short                   TG_INT16;
typedef unsigned long           TG_DWORD;
typedef TG_DWORD                TG_UINT32;
typedef int                     TG_INT32;
typedef short                   TG_BOOL;
typedef float                   TG_FLOAT;
typedef double                  TG_DOUBLE;
typedef short                   TG_STATUS_VAL;   // generic status (ie. result code)
// MAC DEFS
#ifndef pointer
#define pointer					void *
#endif

typedef pointer					TG_HANDLE;
typedef TG_UINT32				TG_pthread_mutex_t;
typedef TG_UINT32				TG_task_id;
#ifndef bool
//typedef char					bool;
#endif


// Record used to convert enum name to value and vice versa
typedef struct
{
    int     inEnumVal;
    TG_CHAR *  pchEnumName;

} ENUM_NAME_REC;

#ifndef NULL
#define NULL	0
#endif
#define POINTER    pointer   // generic pointer type
#define PLTL       pointer  
//***
// Macro definition of simple pointer
//***
#define PTR                     (void *)

//***
// TG_BOOL VALUES
//***
#ifndef TRUE
#define TRUE    0x01
#endif
#ifndef FALSE
#define FALSE   0x00
#endif

#ifndef MEMALLOC
#define MEMALLOC(x)		calloc(1,x)
#define MEMFREE(x)		free(x)
#endif

#endif // __TGT_H_INCLUDED
